#ifndef __INTR
#define __INTR

#ifndef __BOOL
#define __BOOL

enum Bool {FALSE,TRUE};

#endif

/* Safety hack: INT_HANDLER looks like a pointer to a strange structure! */

struct __foo_struct__ {short foo;};            
typedef struct __foo_struct__ *INT_HANDLER;

/* Don't ask me why DEFINE_INT_HANDLER crashes if jsr is replaced with bsr! */
/* It seems that inline assembler is buggy when bsr is used...              */

#define DEFINE_INT_HANDLER(name) \
  struct __foo_struct__ name[]={}; \
  asm(#name##":" \
      "move.w #0x2700,%sr;" \
      "movem.l %d0-%d7/%a0-%a6,-(%sp);" \
      "move.l 0xC8,%a5;" \
      "jsr __"###name##"_body__;" \
      "movem.l (%sp)+,%d0-%d7/%a0-%a6;" \
      "rte"); \
  void __##name##_body__(void)

#define DUMMY_HANDLER ((INT_HANDLER)(short[]){0x4E73})

enum AutoInts {AUTO_INT_1=0x64,AUTO_INT_2=0x68,AUTO_INT_3=0x6C,
  AUTO_INT_4=0x70,AUTO_INT_5=0x74,AUTO_INT_6=0x78,AUTO_INT_7=0x7C};

#define AUTO_INT(i) ((long)(i)*4+0x60)
#define FIRST_AUTO_INT 1
#define LAST_AUTO_INT 7
#define AUTO_INT_COUNT (LAST_AUTO_INT-FIRST_AUTO_INT+1)

#define GetIntVec(i) (*(INT_HANDLER*)(i))
#define SetIntVec(i,h) ((void)(*(INT_HANDLER*)(0x40000+(long)(i))=(h)))

#define ExecuteHandler(h) ({INT_HANDLER __addr=(h); \
  asm("pea 0f; move %%sr,-(%%sp); jmp (%0); 0:"::"a"(__addr)); })

#endif
